#include "inout.h"

void get_uname(char *);
void construct_comment(int argc, char **argv, char *comment);

int main(int argc, char **argv) {

  char cmd[80];
  char uname[IDLEN];
  char comment[COMMENTLEN];
  sqlite3 *db;
  sqlite3_stmt *res, *select_stmt;
  int err;
 
  get_uname(uname);
  construct_comment(argc, argv, comment);

  if ( (err = sqlite3_open(INOUTDB, &db)) != SQLITE_OK) {
    fprintf(stderr, "Error: failed to open database\n");
    exit(1);
  }
  
  sprintf(cmd, "SELECT id FROM inout WHERE id=\'%s\'", uname);

  if ( (err = sqlite3_prepare_v2(db, cmd, strlen(cmd), &select_stmt, NULL)) != SQLITE_OK) {

    fprintf(stderr, "Error: SQL SELECT statement failed (%d).\n", err);
    exit(1);
    
  } else if ( (err = sqlite3_step(select_stmt)) != SQLITE_ROW ) {
    
    sqlite3_finalize(select_stmt);

    sprintf(cmd, "INSERT INTO inout (id, status, comment) VALUES (\'%s\', \'%s\', \'%s\');", uname, STATUS, comment);

    if ((err = sqlite3_exec(db, cmd, NULL, NULL, NULL)) != SQLITE_OK) {
      fprintf(stderr, "Error: unable to insert record in database.\n");
      sqlite3_close(db);
      exit(1);
    }
   
  } else {

    sqlite3_finalize(select_stmt);

    sprintf(cmd, "UPDATE inout SET status=\'%s\', comment=\'%s\' WHERE id=\'%s\';", STATUS, comment, uname);

    if ((err = sqlite3_exec(db, cmd, NULL, NULL, NULL)) != SQLITE_OK) {
      fprintf(stderr, "Error: unable to update record in database.\n");
      sqlite3_close(db);
      exit(1);
    }
  }

  sqlite3_close(db);
}

  
void get_uname(char *id) {
  uid_t uid;
  struct passwd *pwd;

  uid = getuid();
  pwd = getpwuid(uid);

  strncpy(id, pwd->pw_name, IDLEN);

  return;
}

void construct_comment(int argc, char **argv, char *comment) {
  int n = 1;
  char tmp[COMMENTLEN];

  tmp[0] = '\0';

  while (n < argc) {
    strcat(tmp, argv[n++]);
    if (n < argc) {
      strcat(tmp, " ");
    }
  }

  strcpy(comment, tmp);

  return;
}



  
       
